#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Platform::Sysc::Entitytype::UESEntityType
  private_class_method :new

  # Code of entity type entity.
# 
# <tt><b>since</b></tt> UES7-10
  ET_ENTITY_TYPE_CODE = Java::cz.ues.platform.sysc.entitytype.UESEntityType::ET_ENTITY_TYPE_CODE

  # URI of entity type entity.
# 
# <tt><b>since</b></tt> UES7-10
  ET_ENTITY_TYPE_URI = Java::cz.ues.platform.sysc.entitytype.UESEntityType::ET_ENTITY_TYPE_URI


# Returns UESURI of Entity Type for given object.
# 
# <tt><b>param</b></tt> entity UESURI of object for which to get Entity Type
# 
# <tt><b>return</b></tt> UESURI of Entity Type
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case obtaining of BE Type UESURI fails
# 
# <tt><b>since</b></tt> UES7-00
  def self.getEntityTypeUri(entity)
    entity = Ues::Platform::Commons::Uri::UESURI.new(entity).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.getEntityTypeUri(entity)
    if (_r != nil) then _r = Ues::Platform::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias entity_type_uri getEntityTypeUri
  end

# Reads Entity Type attributes according to given UESURI. If there is no Entity Type
# with given UESURI, null is returned.
# 
# <tt><b>param</b></tt> entityType UESURI of Entity Type to be loaded
# 
# <tt><b>return</b></tt> Loaded Entity Type or null if no such Entity Type exists
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case reading of BE Type fails
# 
# <tt><b>deprecated</b></tt> Use UESEntityType#getAttributes(UESURI)
# 
# <tt><b>since</b></tt> UES7-00
  def self.getEntityTypeAttributes(entityType)
    warn "[DEPRECATED: Ues::Platform::Sysc::Entitytype::UESEntityType.getEntityTypeAttributes] Use UESEntityType#getAttributes(UESURI)"
    entityType = Ues::Platform::Commons::Uri::UESURI.new(entityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.getEntityTypeAttributes(entityType)
    if (_r != nil) then _r = Ues::Platform::Sysc::Entitytype::UESEntityTypeAttributes.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias entity_type_attributes getEntityTypeAttributes
  end

# Reads Entity Type attributes according to given UESURI. If there is no Entity Type
# with given UESURI, null is returned.
# 
# <tt><b>param</b></tt> entityType UESURI of Entity Type to be loaded
# 
# <tt><b>return</b></tt> Loaded Entity Type or null if no such Entity Type exists
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case reading of BE Type fails
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(entityType)
    entityType = Ues::Platform::Commons::Uri::UESURI.new(entityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.getAttributes(entityType)
    if (_r != nil) then _r = Ues::Platform::Sysc::Entitytype::UESEntityTypeAttributes.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias attributes getAttributes
  end

# Checks if Entity Type is assignable from other Entity Type. If either
# of Entity Types does not exist, false is returned.
# 
# <tt><b>param</b></tt> mainEntityType UESURI of main Entity Type (parent)
# 
# <tt><b>param</b></tt> testedEntityType UESURI of tested Entity Type (child)
# 
# <tt><b>return</b></tt> True if tested Entity Type is assignable from main Entity Type, false if not
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case check fails.
# 
# <tt><b>since</b></tt> UES7-00
  def self.isAssignableFrom(mainEntityType, testedEntityType = nil)
    mainEntityType = Ues::Platform::Commons::Uri::UESURI.new(mainEntityType).to_java
    testedEntityType = Ues::Platform::Commons::Uri::UESURI.new(testedEntityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.isAssignableFrom(mainEntityType, testedEntityType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias is_assignable_from isAssignableFrom
  end

# Checks if some object is instance of given Entity Type. If given object or
# Entity Type does not exist, false is returned.
# 
# <tt><b>param</b></tt> testedEntity UESURI of object to be tested
# 
# <tt><b>param</b></tt> testedEntityType UESURI of expected Entity Type
# 
# <tt><b>return</b></tt> True if tested object is instance of given Entity Type, false if not
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case check fails.
# 
# <tt><b>since</b></tt> UES7-00
  def self.isInstanceOf(testedEntity, testedEntityType = nil)
    testedEntity = Ues::Platform::Commons::Uri::UESURI.new(testedEntity).to_java
    testedEntityType = Ues::Platform::Commons::Uri::UESURI.new(testedEntityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.isInstanceOf(testedEntity, testedEntityType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias is_instance_of isInstanceOf
  end

# Returns children of given entity type.
# 
# <tt><b>param</b></tt> entityTypeUri UESURI of main Entity Type (parent)
# 
# <tt><b>param</b></tt> UESEntityTypeGetChildrenList Criteria for filtering of result
# 
# <tt><b>return</b></tt> List of children (sorted by level and parent). Null if given parent entity does not exist.
# 
# <tt><b>throws</b></tt> UESEntityTypeRTException In case obtaining of children fails
# 
# <tt><b>since</b></tt> UES7-10
  def self.getChildrenList(entityType, criteria = nil)
    entityType = Ues::Platform::Commons::Uri::UESURI.new(entityType).to_java
    criteria = Ues::Platform::Sysc::Entitytype::UESEntityTypeGetChildrenList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityType.java_class)
    _r = _s.getChildrenList(entityType, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityType
    alias children_list getChildrenList
  end
end
